#include <stdio.h>
#include <stdlib.h>

int main()
{
    int i,j;
    long long n,m,c,ai,x;
    int long b[m],a[n];
    scanf("%lld",&n);
    scanf("%lld",&m);
    for(i=1;i<=m;i++){
        scanf("%ld",&b[i]);
    }
    for(i=1;i<=n;i++){
        a[i]=i;
    }
    for (j=1; j<=m; j++){
    a[i + b[j]] = a[i + j];
    }
    scanf("%lld",&c);
    for(i=1;i<=n;i++){
        x=c^i*a[i];
    }
    x=x%998244353;
    printf("%lld",x);
    return 0;
}